-----------------------------------------------------------------------------------------------
-- Client Lua Script for MaxMoneyRecord
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- MaxMoneyRecord Module Definition
-----------------------------------------------------------------------------------------------
local MaxMoneyRecord = {} 

MaxMoneyRecord.LineObject = nil

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function MaxMoneyRecord:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function MaxMoneyRecord:Init()
    Apollo.RegisterAddon(self, false)
end
 

-----------------------------------------------------------------------------------------------
-- MaxMoneyRecord OnLoad
-----------------------------------------------------------------------------------------------
function MaxMoneyRecord:OnLoad()
	self.config = Apollo.GetPackage("Gemini:DB-1.0").tPackage:New(self)
	Apollo.RegisterEventHandler("LootedMoney", "OnGetMoney", self)
	self.xmlDoc = XmlDoc.CreateFromFile("MaxMoneyRecord.xml")
	self:InitVariables()
end

-----------------------------------------------------------------------------------------------
-- MaxMoneyRecord OnDocLoaded
-----------------------------------------------------------------------------------------------
function MaxMoneyRecord:InitVariables()
	if self.config.char.MaxMoney == nil or GameLib.GetPlayerCurrency(1):GetAmount() > self.config.char.MaxMoney then
		self.config.char.MaxMoney = GameLib.GetPlayerCurrency(1):GetAmount()
		Print("Update amount to " .. self.config.char.MaxMoney)
	end

	if self.LineObject == nil then
		if AddCharacterInformationLine ~= nil then
			self.LineObject = AddCharacterInformationLine(
			"MaxMoneyRecord",
			"Money Record",
			function() 
				if self.LineObject.wnd ~= nil and self.LineObject.wnd:FindChild("Cash") == nil then
					Apollo.LoadForm(self.xmlDoc, "Cash", self.LineObject.wnd:FindChild("Value"), self)
				end
				if self.LineObject.wnd:FindChild("Cash") ~= nil then
					self.LineObject.wnd:FindChild("Cash"):SetAmount(self.config.char.MaxMoney)
				end
				return "" 
			end,
			nil, 
			nil,
			"This is the maximum amount of money you ever have.")
		else
			self.LineObject = nil
		end
	end
	
	if self.LineObject ~= nil and self.LineObject.wnd ~= nil and self.LineObject.wnd:FindChild("Cash") == nil then
		Apollo.LoadForm(self.xmlDoc, "Cash", self.LineObject.wnd:FindChild("Value"), self)
	end
		
end

-----------------------------------------------------------------------------------------------
-- MaxMoneyRecord Functions
-----------------------------------------------------------------------------------------------
function MaxMoneyRecord:OnGetMoney(monLooted)
	local eCurrencyType = monLooted:GetMoneyType()
	if eCurrencyType ~= Money.CodeEnumCurrencyType.Credits then
		return
	end

	self:InitVariables()
  
  	if GameLib.GetPlayerCurrency(1):GetAmount() + monLooted:GetAmount() > self.config.char.MaxMoney then
		self.config.char.MaxMoney = GameLib.GetPlayerCurrency(1):GetAmount() + monLooted:GetAmount()
		if self.LineObject ~= nil then
			self.LineObject:forceUpdate()
		else
			Print("<MaxMoneyRecord> You need to install the addon 'CharacterInfoPlus' (http://www.curse.com/ws-addons/wildstar/222978-characterinfoplus) to visualize the new amount into the character window.")
		end
	end
end

-----------------------------------------------------------------------------------------------
-- MaxMoneyRecord Instance
-----------------------------------------------------------------------------------------------
local MaxMoneyRecordInst = MaxMoneyRecord:new()
MaxMoneyRecordInst:Init()
